<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
  <head>
    <meta charset="utf-8" />
    <meta name="generator" content="pandoc" />
    <meta
      name="viewport"
      content="width=device-width, initial-scale=1.0, user-scalable=yes"
    />
    <title>article (125)</title>
    <style type="text/css">
      code {
        white-space: pre-wrap;
      }
      span.smallcaps {
        font-variant: small-caps;
      }
      span.underline {
        text-decoration: underline;
      }
      div.column {
        display: inline-block;
        vertical-align: top;
        width: 50%;
      }
    </style>
    <style type="text/css">
      a.sourceLine {
        display: inline-block;
        line-height: 1.25;
      }
      a.sourceLine {
        pointer-events: none;
        color: inherit;
        text-decoration: inherit;
      }
      a.sourceLine:empty {
        height: 1.2em;
      }
      .sourceCode {
        overflow: visible;
      }
      code.sourceCode {
        white-space: pre;
        position: relative;
      }
      div.sourceCode {
        margin: 1em 0;
      }
      pre.sourceCode {
        margin: 0;
      }
      @media screen {
        div.sourceCode {
          overflow: auto;
        }
      }
      @media print {
        code.sourceCode {
          white-space: pre-wrap;
        }
        a.sourceLine {
          text-indent: -1em;
          padding-left: 1em;
        }
      }
      pre.numberSource a.sourceLine {
        position: relative;
        left: -4em;
      }
      pre.numberSource a.sourceLine::before {
        content: attr(title);
        position: relative;
        left: -1em;
        text-align: right;
        vertical-align: baseline;
        border: none;
        pointer-events: all;
        display: inline-block;
        -webkit-touch-callout: none;
        -webkit-user-select: none;
        -khtml-user-select: none;
        -moz-user-select: none;
        -ms-user-select: none;
        user-select: none;
        padding: 0 4px;
        width: 4em;
        color: #aaaaaa;
      }
      pre.numberSource {
        margin-left: 3em;
        border-left: 1px solid #aaaaaa;
        padding-left: 4px;
      }
      div.sourceCode {
      }
      @media screen {
        a.sourceLine::before {
          text-decoration: underline;
        }
      }
      code span.al {
        color: #ff0000;
        font-weight: bold;
      } /* Alert */
      code span.an {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Annotation */
      code span.at {
        color: #7d9029;
      } /* Attribute */
      code span.bn {
        color: #40a070;
      } /* BaseN */
      code span.bu {
      } /* BuiltIn */
      code span.cf {
        color: #007020;
        font-weight: bold;
      } /* ControlFlow */
      code span.ch {
        color: #4070a0;
      } /* Char */
      code span.cn {
        color: #880000;
      } /* Constant */
      code span.co {
        color: #60a0b0;
        font-style: italic;
      } /* Comment */
      code span.cv {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* CommentVar */
      code span.do {
        color: #ba2121;
        font-style: italic;
      } /* Documentation */
      code span.dt {
        color: #902000;
      } /* DataType */
      code span.dv {
        color: #40a070;
      } /* DecVal */
      code span.er {
        color: #ff0000;
        font-weight: bold;
      } /* Error */
      code span.ex {
      } /* Extension */
      code span.fl {
        color: #40a070;
      } /* Float */
      code span.fu {
        color: #06287e;
      } /* Function */
      code span.im {
      } /* Import */
      code span.in {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Information */
      code span.kw {
        color: #007020;
        font-weight: bold;
      } /* Keyword */
      code span.op {
        color: #666666;
      } /* Operator */
      code span.ot {
        color: #007020;
      } /* Other */
      code span.pp {
        color: #bc7a00;
      } /* Preprocessor */
      code span.sc {
        color: #4070a0;
      } /* SpecialChar */
      code span.ss {
        color: #bb6688;
      } /* SpecialString */
      code span.st {
        color: #4070a0;
      } /* String */
      code span.va {
        color: #19177c;
      } /* Variable */
      code span.vs {
        color: #4070a0;
      } /* VerbatimString */
      code span.wa {
        color: #60a0b0;
        font-weight: bold;
        font-style: italic;
      } /* Warning */
    </style>
  </head>
  <body>
    <h1 id="popups-and-window-methods">Popups and window methods</h1>
    <p>
      A popup window is one of the oldest methods to show additional document to
      user.
    </p>
    <p>Basically, you just run:</p>
    <div class="sourceCode" id="cb1">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="va">window</span>.<span class="at">open</span>(<span class="st">&quot;https://javascript.info/&quot;</span>)<span class="op">;</span></a></code></pre>
    </div>
    <p>
      …And it will open a new window with given URL. Most modern browsers are
      configured to open url in new tabs instead of separate windows.
    </p>
    <p>
      Popups exist from really ancient times. The initial idea was to show
      another content without closing the main window. As of now, there are
      other ways to do that: we can load content dynamically with
      <a href="info:fetch">fetch</a> and show it in a dynamically generated
      <code>&lt;div&gt;</code>. So, popups is not something we use everyday.
    </p>
    <p>
      Also, popups are tricky on mobile devices, that don’t show multiple
      windows simultaneously.
    </p>
    <ol type="1">
      <li>
        A popup is a separate window which has its own independent JavaScript
        environment. So opening a popup from a third-party, non-trusted site is
        safe.
      </li>
      <li>It’s very easy to open a popup.</li>
      <li>
        A popup can navigate (change URL) and send messages to the opener
        window.
      </li>
    </ol>
    <h2 id="popup-blocking">Popup blocking</h2>
    <p>
      In the past, evil sites abused popups a lot. A bad page could open tons of
      popup windows with ads. So now most browsers try to block popups and
      protect the user.
    </p>
    <p>
      <strong
        >Most browsers block popups if they are called outside of user-triggered
        event handlers like <code>onclick</code>.</strong
      >
    </p>
    <p>For example:</p>
    <div class="sourceCode" id="cb2">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="co">// popup blocked</span></a>
<a class="sourceLine" id="cb2-2" title="2"><span class="va">window</span>.<span class="at">open</span>(<span class="st">&quot;https://javascript.info&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-3" title="3"></a>
<a class="sourceLine" id="cb2-4" title="4"><span class="co">// popup allowed</span></a>
<a class="sourceLine" id="cb2-5" title="5"><span class="va">button</span>.<span class="at">onclick</span> <span class="op">=</span> () <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-6" title="6">  <span class="va">window</span>.<span class="at">open</span>(<span class="st">&quot;https://javascript.info&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-7" title="7"><span class="op">};</span></a></code></pre>
    </div>
    <p>
      This way users are somewhat protected from unwanted popups, but the
      functionality is not disabled totally.
    </p>
    <p>
      What if the popup opens from <code>onclick</code>, but after
      <code>setTimeout</code>? That’s a bit tricky.
    </p>
    <p>Try this code:</p>
    <p>
      <code
        >js run // open after 3 seconds setTimeout(() =&gt;
        window.open("http://google.com"), 3000);</code
      >
    </p>
    <p>The popup opens in Chrome, but gets blocked in Firefox.</p>
    <p>…If we decrease the delay, the popup works in Firefox too:</p>
    <p>
      <code
        >js run // open after 1 seconds setTimeout(() =&gt;
        window.open("http://google.com"), 1000);</code
      >
    </p>
    <p>
      The difference is that Firefox treats a timeout of 2000ms or less are
      acceptable, but after it – removes the “trust”, assuming that now it’s
      “outside of the user action”. So the first one is blocked, and the second
      one is not.
    </p>
    <h2 id="window.open">window.open</h2>
    <p>
      The syntax to open a popup is:
      <code>window.open(url, name, params)</code>:
    </p>
    <dl>
      <dt>url</dt>
      <dd>An URL to load into the new window.</dd>
      <dt>name</dt>
      <dd>
        A name of the new window. Each window has a <code>window.name</code>,
        and here we can specify which window to use for the popup. If there’s
        already a window with such name – the given URL opens in it, otherwise a
        new window is opened.
      </dd>
      <dt>params</dt>
      <dd>
        The configuration string for the new window. It contains settings,
        delimited by a comma. There must be no spaces in params, for instance:
        <code>width=200,height=100</code>.
      </dd>
    </dl>
    <p>Settings for <code>params</code>:</p>
    <ul>
      <li>
        Position:
        <ul>
          <li>
            <code>left/top</code> (numeric) – coordinates of the window top-left
            corner on the screen. There is a limitation: a new window cannot be
            positioned offscreen.
          </li>
          <li>
            <code>width/height</code> (numeric) – width and height of a new
            window. There is a limit on minimal width/height, so it’s impossible
            to create an invisible window.
          </li>
        </ul>
      </li>
      <li>
        Window features:
        <ul>
          <li>
            <code>menubar</code> (yes/no) – shows or hides the browser menu on
            the new window.
          </li>
          <li>
            <code>toolbar</code> (yes/no) – shows or hides the browser
            navigation bar (back, forward, reload etc) on the new window.
          </li>
          <li>
            <code>location</code> (yes/no) – shows or hides the URL field in the
            new window. FF and IE don’t allow to hide it by default.
          </li>
          <li>
            <code>status</code> (yes/no) – shows or hides the status bar. Again,
            most browsers force it to show.
          </li>
          <li>
            <code>resizable</code> (yes/no) – allows to disable the resize for
            the new window. Not recommended.
          </li>
          <li>
            <code>scrollbars</code> (yes/no) – allows to disable the scrollbars
            for the new window. Not recommended.
          </li>
        </ul>
      </li>
    </ul>
    <p>
      There is also a number of less supported browser-specific features, which
      are usually not used. Check
      <a href="https://developer.mozilla.org/en/DOM/window.open"
        >window.open in MDN</a
      >
      for examples.
    </p>
    <h2 id="example-a-minimalistic-window">Example: a minimalistic window</h2>
    <p>
      Let’s open a window with minimal set of features, just to see which of
      them browser allows to disable:
    </p>
    <p>
      ``<code>js run let params =</code
      >scrollbars=no,resizable=no,status=no,location=no,toolbar=no,menubar=no,
      width=0,height=0,left=-1000,top=-1000`;
    </p>
    <p>open(“/”, “test”, params); ```</p>
    <p>
      Here most “window features” are disabled and window is positioned
      offscreen. Run it and see what really happens. Most browsers “fix” odd
      things like zero <code>width/height</code> and offscreen
      <code>left/top</code>. For instance, Chrome open such a window with full
      width/height, so that it occupies the full screen.
    </p>
    <p>
      Let’s add normal positioning options and reasonable <code>width</code>,
      <code>height</code>, <code>left</code>, <code>top</code> coordinates:
    </p>
    <p>
      ``<code>js run let params =</code
      >scrollbars=no,resizable=no,status=no,location=no,toolbar=no,menubar=no,
      width=600,height=300,left=100,top=100`;
    </p>
    <p>open(“/”, “test”, params); ```</p>
    <p>Most browsers show the example above as required.</p>
    <p>Rules for omitted settings:</p>
    <ul>
      <li>
        If there is no 3rd argument in the <code>open</code> call, or it is
        empty, then the default window parameters are used.
      </li>
      <li>
        If there is a string of params, but some <code>yes/no</code> features
        are omitted, then the omitted features assumed to have
        <code>no</code> value. So if you specify params, make sure you
        explicitly set all required features to yes.
      </li>
      <li>
        If there is no <code>left/top</code> in params, then the browser tries
        to open a new window near the last opened window.
      </li>
      <li>
        If there is no <code>width/height</code>, then the new window will be
        the same size as the last opened.
      </li>
    </ul>
    <h2 id="accessing-popup-from-window">Accessing popup from window</h2>
    <p>
      The <code>open</code> call returns a reference to the new window. It can
      be used to manipulate it’s properties, change location and even more.
    </p>
    <p>In this example, we generate popup content from JavaScript:</p>
    <div class="sourceCode" id="cb3">
      <pre
        class="sourceCode js"
      ><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="kw">let</span> newWin <span class="op">=</span> <span class="va">window</span>.<span class="at">open</span>(<span class="st">&quot;about:blank&quot;</span><span class="op">,</span> <span class="st">&quot;hello&quot;</span><span class="op">,</span> <span class="st">&quot;width=200,height=200&quot;</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-2" title="2"></a>
<a class="sourceLine" id="cb3-3" title="3"><span class="va">newWin</span>.<span class="va">document</span>.<span class="at">write</span>(<span class="st">&quot;Hello, world!&quot;</span>)<span class="op">;</span></a></code></pre>
    </div>
    <p>And here we modify the contents after loading:</p>
    <p>
      ```js run let newWindow = open(‘/’, ‘example’, ‘width=300,height=300’)
      newWindow.focus();
    </p>
    <p>
      alert(newWindow.location.href); // (*) about:blank, loading hasn’t started
      yet
    </p>
    <p>
      newWindow.onload = function() { let html =
      <code>&lt;div style="font-size:30px"&gt;Welcome!&lt;/div&gt;</code>;
      <em>!</em> newWindow.document.body.insertAdjacentHTML(‘afterbegin’, html);
      <em>/!</em> }; ```
    </p>
    <p>
      Please note: immediately after <code>window.open</code>, the new window
      isn’t loaded yet. That’s demonstrated by <code>alert</code> in line
      <code>(*)</code>. So we wait for <code>onload</code> to modify it. We
      could also use <code>DOMContentLoaded</code> handler for
      <code>newWin.document</code>.
    </p>
    <p>
      ```warn header=“Same origin policy” Windows may freely access content of
      each other only if they come from the same origin (the same
      protocol://domain:port).
    </p>
    <p>
      Otherwise, e.g. if the main window is from <code>site.com</code>, and the
      popup from <code>gmail.com</code>, that’s impossible for user safety
      reasons. For the details, see chapter
      <a href="info:cross-window-communication" class="uri"
        >info:cross-window-communication</a
      >. ```
    </p>
    <h2 id="accessing-window-from-popup">Accessing window from popup</h2>
    <p>
      A popup may access the “opener” window as well using
      <code>window.opener</code> reference. It is <code>null</code> for all
      windows except popups.
    </p>
    <p>
      If you run the code below, it replaces the opener (current) window content
      with “Test”:
    </p>
    <p>
      ```js run let newWin = window.open(“about:blank”, “hello”,
      “width=200,height=200”);
    </p>
    newWin.document.write( "
    <script>
      window.opener.document.body.innerHTML = "Test";
    </script>
    <p>" ); ```</p>
    <p>
      So the connection between the windows is bidirectional: the main window
      and the popup have a reference to each other.
    </p>
    <h2 id="closing-a-popup">Closing a popup</h2>
    <p>To close a window: <code>win.close()</code>.</p>
    <p>To check if a window is closed: <code>win.closed</code>.</p>
    <p>
      Technically, the <code>close()</code> method is available for any
      <code>window</code>, but <code>window.close()</code> is ignored by most
      browsers if <code>window</code> is not created with
      <code>window.open()</code>. So it’ll only work on a popup.
    </p>
    <p>
      The <code>closed</code> property is <code>true</code> if the window is
      closed. That’s useful to check if the popup (or the main window) is still
      open or not. A user can close it anytime, and our code should take that
      possibility into account.
    </p>
    <p>This code loads and then closes the window:</p>
    <p>
      ```js run let newWindow = open(“/”, “example”, “width=300,height=300”);
    </p>
    <p>
      newWindow.onload = function () { newWindow.close();
      alert(newWindow.closed); // true }; ```
    </p>
    <h2 id="moving-and-resizing">Moving and resizing</h2>
    <p>There are methods to move/resize a window:</p>
    <dl>
      <dt><code>win.moveBy(x,y)</code></dt>
      <dd>
        Move the window relative to current position <code>x</code> pixels to
        the right and <code>y</code> pixels down. Negative values are allowed
        (to move left/up).
      </dd>
      <dt><code>win.moveTo(x,y)</code></dt>
      <dd>Move the window to coordinates <code>(x,y)</code> on the screen.</dd>
      <dt><code>win.resizeBy(width,height)</code></dt>
      <dd>
        Resize the window by given <code>width/height</code> relative to the
        current size. Negative values are allowed.
      </dd>
      <dt><code>win.resizeTo(width,height)</code></dt>
      <dd>Resize the window to the given size.</dd>
    </dl>
    <p>There’s also <code>window.onresize</code> event.</p>
    <p>
      <code
        >warn header="Only popups" To prevent abuse, the browser usually blocks
        these methods. They only work reliably on popups that we opened, that
        have no additional tabs.</code
      >
    </p>
    <p>
      ```warn header=“No minification/maximization” JavaScript has no way to
      minify or maximize a window. These OS-level functions are hidden from
      Frontend-developers.
    </p>
    <p>Move/resize methods do not work for maximized/minimized windows. ```</p>
    <h2 id="scrolling-a-window">Scrolling a window</h2>
    <p>
      We already talked about scrolling a window in the chapter
      <a href="info:size-and-scroll-window" class="uri"
        >info:size-and-scroll-window</a
      >.
    </p>
    <dl>
      <dt><code>win.scrollBy(x,y)</code></dt>
      <dd>
        Scroll the window <code>x</code> pixels right and <code>y</code> down
        relative the current scroll. Negative values are allowed.
      </dd>
      <dt><code>win.scrollTo(x,y)</code></dt>
      <dd>Scroll the window to the given coordinates <code>(x,y)</code>.</dd>
      <dt><code>elem.scrollIntoView(top = true)</code></dt>
      <dd>
        Scroll the window to make <code>elem</code> show up at the top (the
        default) or at the bottom for <code>elem.scrollIntoView(false)</code>.
      </dd>
    </dl>
    <p>There’s also <code>window.onscroll</code> event.</p>
    <h2 id="focusblur-on-a-window">Focus/blur on a window</h2>
    <p>
      Theoretically, there are <code>window.focus()</code> and
      <code>window.blur()</code> methods to focus/unfocus on a window. And there
      are also <code>focus/blur</code> events that allow to catch the moment
      when the visitor focuses on a window and switches elsewhere.
    </p>
    <p>
      Although, in practice they are severely limited, because in the past evil
      pages abused them.
    </p>
    <p>For instance, look at this code:</p>
    <p><code>js run window.onblur = () =&gt; window.focus();</code></p>
    <p>
      When a user attempts to switch out of the window
      (<code>window.onblur</code>), it brings the window back into focus. The
      intention is to “lock” the user within the <code>window</code>.
    </p>
    <p>
      So browsers had to introduce many limitations to forbid the code like that
      and protect the user from ads and evils pages. They depend on the browser.
    </p>
    <p>
      For instance, a mobile browser usually ignores
      <code>window.focus()</code> completely. Also focusing doesn’t work when a
      popup opens in a separate tab rather than a new window.
    </p>
    <p>
      Still, there are some use cases when such calls do work and can be useful.
    </p>
    <p>For instance:</p>
    <ul>
      <li>
        When we open a popup, it’s might be a good idea to run a
        <code>newWindow.focus()</code> on it. Just in case, for some OS/browser
        combinations it ensures that the user is in the new window now.
      </li>
      <li>
        If we want to track when a visitor actually uses our web-app, we can
        track <code>window.onfocus/onblur</code>. That allows us to
        suspend/resume in-page activities, animations etc. But please note that
        the <code>blur</code> event means that the visitor switched out from the
        window, but they still may observe it. The window is in the background,
        but still may be visible.
      </li>
    </ul>
    <h2 id="summary">Summary</h2>
    <p>
      Popup windows are used rarely, as there are alternatives: loading and
      displaying information in-page, or in iframe.
    </p>
    <p>
      If we’re going to open a popup, a good practice is to inform the user
      about it. An “opening window” icon near a link or button would allow the
      visitor to survive the focus shift and keep both windows in mind.
    </p>
    <ul>
      <li>
        A popup can be opened by the <code>open(url, name, params)</code> call.
        It returns the reference to the newly opened window.
      </li>
      <li>
        Browsers block <code>open</code> calls from the code outside of user
        actions. Usually a notification appears, so that a user may allow them.
      </li>
      <li>
        Browsers open a new tab by default, but if sizes are provided, then
        it’ll be a popup window.
      </li>
      <li>
        The popup may access the opener window using the
        <code>window.opener</code> property.
      </li>
      <li>
        The main window and the popup can freely read and modify each other if
        they have the same origin. Otherwise, they can change location of each
        other and
        <a href="info:cross-window-communication">exchange messages</a>.
      </li>
    </ul>
    <p>
      To close the popup: use <code>close()</code> call. Also the user may close
      them (just like any other windows). The <code>window.closed</code> is
      <code>true</code> after that.
    </p>
    <ul>
      <li>
        Methods <code>focus()</code> and <code>blur()</code> allow to
        focus/unfocus a window. But they don’t work all the time.
      </li>
      <li>
        Events <code>focus</code> and <code>blur</code> allow to track switching
        in and out of the window. But please note that a window may still be
        visible even in the background state, after <code>blur</code>.
      </li>
    </ul>
  </body>
</html>
